package me.fatmarley.fatgiants;

import java.util.Random;

import org.bukkit.Location;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.Listener;
import org.bukkit.event.entity.CreatureSpawnEvent;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.entity.EntityTargetEvent;
import org.bukkit.inventory.ItemStack;

public class entityListener implements Listener {
	fatgiants plugin;
	public int itemID;
	public byte dataID;
	public int quantity;

	public entityListener(fatgiants plugin) {
		this.plugin = plugin;
	}

	@EventHandler
	public void onEntityTarget(EntityTargetEvent event) {
		Entity target = event.getTarget();
		Entity entity = event.getEntity();
		if ((entity instanceof LivingEntity)) {
			LivingEntity livingentity = (LivingEntity) entity;
			if ((this.plugin.isGiant(livingentity))
					&& ((target instanceof Player))) {
				if (plugin.getConfig().getBoolean("FireAttack")) {
					event.getEntity().setFireTicks(2);
					int mf = target.getMaxFireTicks();
					target.setFireTicks(mf);
					event.setCancelled(true);
				}

			}

		}
	}

	@EventHandler
	public void onEntityDamage(EntityDamageEvent event) {
		Entity entity = event.getEntity();
		if ((entity instanceof LivingEntity)) {
			LivingEntity livingentity = (LivingEntity) entity;
			if ((this.plugin.isGiant(livingentity))
					&& ((event instanceof EntityDamageByEntityEvent))) {
				EntityDamageByEntityEvent sub = (EntityDamageByEntityEvent) event;
				Entity entity2 = sub.getDamager();
				if ((entity2 instanceof Player)) {
					int Health = livingentity.getHealth();
					int damage = event.getDamage();

					int hd = Health - damage;
					if (hd == 200) {
						damage++;
					}
					if (Health == 200) {

						int sethealth = plugin.getConfig().getInt("Health");
						livingentity.setHealth(sethealth);
						Health = sethealth;
					}
					String ItemInfo = plugin.getConfig().getString("Drops");
					String[] itemData = ItemInfo.split(":");
					if ((damage >= Health) && (itemData.length == 3)) {
						event.getEntity().remove();
						Location location = event.getEntity().getLocation();
						int itemID = Integer.parseInt(itemData[0]);
						byte dataID = Byte.parseByte(itemData[1]);
						int quantity = Integer.parseInt(itemData[2]);
						int dcount = 0;
						ItemStack Alldrops = new ItemStack(itemID, 1, dataID);
						while (dcount < quantity) {
							event.getEntity().getWorld()
									.dropItemNaturally(location, Alldrops);
							dcount++;}
							
						} 
							else if ((damage >= Health) && (itemData.length == 2)) {
								event.getEntity().remove();
								Location location = event.getEntity().getLocation();
							int itemID = Integer.parseInt(itemData[0]);
							byte dataID = 0;
							int quantity = Integer.parseInt(itemData[1]);
							int dcount = 0;
							ItemStack Alldrops = new ItemStack(itemID, 1, dataID);
							while (dcount < quantity) {
								event.getEntity().getWorld()
										.dropItemNaturally(location, Alldrops);
								dcount++;
						}
							
							}

						}

					}
				}
			}

	@EventHandler(priority = EventPriority.NORMAL)
	public void onCreatureSpawn(CreatureSpawnEvent event) {
		Entity entity = event.getEntity();
		event.getEntityType();

		if ((event.getEntityType() == EntityType.ZOMBIE)
				|| (event.getEntityType() == EntityType.SKELETON)
				|| (event.getEntityType() == EntityType.SPIDER)
				|| (event.getEntityType() == EntityType.CREEPER)) {
			int srate = plugin.getConfig().getInt("SpawnRate");
			int chance = 100 - (int) srate;

			Random rand = new Random();
			int choice = rand.nextInt(100) < chance ? 1 : 0;
			if (choice == 0) {
				Location location = event.getEntity().getLocation();
				double x = location.getX();
				double y = location.getY();
				double z = location.getZ();

				int x2 = (int) x;
				int y2 = (int) y;
				int z2 = (int) z;

				int spawngiant = 1;
				int checkcount = 0;
				while (checkcount < 10) {
					y2 += checkcount;

					if (entity.getWorld().getBlockTypeIdAt(x2, y2, z2) != 0) {
						spawngiant = 0;
					}
					checkcount++;
				}
				if (spawngiant == 1)
					entity.getWorld().spawnCreature(location, EntityType.GIANT);
			}
		}

	}
}

/*
 * OLD CODE if (damage >= Health) {
 * event.getEntity().remove(); Location location =
 * event.getEntity().getLocation(); int item =
 * plugin.getConfig().getInt("Drops"); int itemamount =
 * plugin.getConfig() .getInt("itemamount"); int dcount
 * = 0; ItemStack ourItem = new ItemStack(item, 1);
 * while (dcount < itemamount) {
 * event.getEntity().getWorld()
 * .dropItemNaturally(location, ourItem); dcount++;
 */
